package com.bizmatics.service.impl;

import com.bizmatics.common.core.bean.CommonPage;
import com.bizmatics.common.mvc.base.AbstractCrudService;
import com.bizmatics.model.SiteArchives;
import com.bizmatics.model.Sitedtl;
import com.bizmatics.model.system.SysUser;
import com.bizmatics.model.vo.SitedtlArchivesVo;
import com.bizmatics.model.vo.SitedtlVo;
import com.bizmatics.persistence.mapper.SitedtlMapper;
import com.bizmatics.service.SiteArchivesService;
import com.bizmatics.service.SitedtlService;
import com.bizmatics.service.es.RtAnalogService;
import com.bizmatics.service.util.SecurityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * 运维管理-现场档案
 *
 * @author ya
 * @since 2021-10-26
 */
@Service
public class SitedtlServiceImpl extends AbstractCrudService<SitedtlMapper, Sitedtl> implements SitedtlService {

    @Autowired
    private SiteArchivesService siteArchivesService;

    @Override
    public void sitedtlAdd(SitedtlArchivesVo sitedtlArchivesVo){
        SysUser user = SecurityUtils.getLoginUser().getUser();
        Sitedtl sitedtl = sitedtlArchivesVo.getSitedtl();
        SiteArchives siteArchives = sitedtlArchivesVo.getSiteArchives();
        sitedtl.setCreator(user.getUserName());
        sitedtl.setCreateTime(new Date());
        this.save(sitedtl);
        Integer sitedtlId = sitedtl.getId();
        siteArchives.setSitedtlId(sitedtlId);
        siteArchivesService.save(siteArchives);
    }

    public void sitedtlUpdate(SitedtlArchivesVo sitedtlArchivesVo){
        this.updateById(sitedtlArchivesVo.getSitedtl());
        siteArchivesService.updateById(sitedtlArchivesVo.getSiteArchives());
    }

    public CommonPage<SitedtlVo> sitedtlList(Integer siteId,String electricTestOverdue,Integer size , Integer current){
        List<SitedtlVo> sitedtlList = baseMapper.sitedtlVoList(siteId,electricTestOverdue,null,null);
        int total = 0;
        if (sitedtlList.size()>0){
            total = sitedtlList.size();
        }

        int startCurrent = (current - 1) * size;
        List<SitedtlVo> sitedtlListOne = baseMapper.sitedtlVoList(siteId,electricTestOverdue,startCurrent,size);
        return new CommonPage<>(sitedtlListOne, total, size, current);
    }
}
